unit SQLConnect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Registry;

type
  TSQLConnect = class(TComponent)
  private
    FDatabase : TDatabase;
    FCheck    : Boolean;
    FServerName : String;
    FUserName : String;
  protected
    { Protected declarations }
  public
    FKey      : String;
    constructor Create( AOwner : TComponent ); override;
    destructor Destroy; override;
    function SetDBParams : boolean;
  published
    property Database : TDatabase
       read FDatabase
       write FDatabase;
    property CheckOnExec : Boolean
       read FCheck
       write FCheck;
    property RootKey : String
       read FKey
       write FKey;
    property ServerName : String
       read FServerName
       write FServerName;
    property UserName : String
       read FUserName
       write FUserName;
  end;

procedure Register;

implementation

Uses Connect;

constructor TSQLConnect.Create( AOwner : TComponent );
begin
   inherited Create( AOwner );
end;

destructor TSQLConnect.Destroy;
begin
   inherited Destroy;
end;

function TSQLConnect.SetDBParams : boolean;
var
   Ir : TRegistry;
begin
   Ir := TRegistry.Create;
   Ir.RootKey := HKEY_CURRENT_USER;
   if Ir.OpenKey( FKey, False ) then
     if FCheck then
     begin
       FDatabase.Close;
       FDatabase.Params.Values['SERVER NAME'] := Ir.ReadString( 'SERVER NAME' );
       FDatabase.Params.Values['USER NAME'] := Ir.ReadString( 'USER NAME' );
       FDatabase.Params.Values['PASSWORD'] := Ir.ReadString( 'PASSWORD' );
       FDatabase.Params.Values['LANGDRIVER'] := Ir.ReadString( 'LANGDRIVER' );
       Result := True;
       FServerName := Ir.ReadString( 'SERVER NAME' );
       FUserName := Ir.ReadString( 'USER NAME' );
       Exit;
    end;
   Ir.CloseKey;
   Ir.Free;

   ConnectForm := TConnectForm.Create( Application );
   try
     if ConnectForm.ShowModal = mrOK then
     begin
       FDatabase.Close;
       FDatabase.Params.Values['SERVER NAME'] := ConnectForm.ServerName.Text;
       FDatabase.Params.Values['USER NAME'] := ConnectForm.UserName.Text;
       FDatabase.Params.Values['PASSWORD'] := ConnectForm.Password.Text;
       FDatabase.Params.Values['LANGDRIVER'] := 'DBWINWE0';
       Ir := TRegistry.Create;
       Ir.RootKey := HKEY_CURRENT_USER;
       Ir.OpenKey( FKey, True );
       with Ir do
       begin
          WriteString( 'SERVER NAME', ConnectForm.ServerName.Text );
          WriteString( 'USER NAME', ConnectForm.UserName.Text );
          WriteString( 'PASSWORD', ConnectForm.Password.Text );
          WriteString( 'LANGDRIVER', 'DBWINWE0' );
       end;
       Ir.CloseKey;
       Ir.Free;
       Result := True;
       FServerName := ConnectForm.ServerName.Text;
       FUserName := ConnectForm.UserName.Text;
     end
     else
       Result := False;
   finally
       ConnectForm.Free;
   end;
end;

procedure Register;
begin
  RegisterComponents('System', [TSQLConnect]);
end;

end.
